// src/common/data/html.ts
function escapeHTML(s) {
  return s.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/'/g, "&apos;").replace(/"/g, "&quot;");
}
function unescapeHTML(s) {
  return s.replace(/&lt;/gi, "<").replace(/&gt;/gi, ">").replace(/&quot;/gi, '"').replace(/&apos;/gi, "'").replace(/&amp;/gi, "&");
}

export {
  escapeHTML,
  unescapeHTML
};
//# sourceMappingURL=chunk-FL5CT6MC.js.map