"use strict";Object.defineProperty(exports, "__esModule", {value: true});


var _chunkS4V3EGNScjs = require('./chunk-S4V3EGNS.cjs');



var _chunkHHZVPIBDcjs = require('./chunk-HHZVPIBD.cjs');

// src/common/msg/encoder.ts
var NoopEncoder = class {
  async encode(data) {
    return data;
  }
  async decode(data) {
    return data;
  }
};
var JsonEncoder = class {
  async encode(data) {
    return _chunkHHZVPIBDcjs.jsonToUint8Array.call(void 0, data);
  }
  async decode(data) {
    return _chunkHHZVPIBDcjs.Uint8ArrayToJson.call(void 0, data);
  }
};
var CryptoEncoder = class {
  constructor(key) {
    this.key = key;
  }
  async encode(data) {
    const plain = _chunkHHZVPIBDcjs.jsonToUint8Array.call(void 0, data);
    return await _chunkS4V3EGNScjs.encrypt.call(void 0, plain, this.key);
  }
  async decode(data) {
    const plain = await _chunkS4V3EGNScjs.decrypt.call(void 0, data, this.key);
    return _chunkHHZVPIBDcjs.Uint8ArrayToJson.call(void 0, plain);
  }
};





exports.NoopEncoder = NoopEncoder; exports.JsonEncoder = JsonEncoder; exports.CryptoEncoder = CryptoEncoder;
//# sourceMappingURL=chunk-QLIFS36C.cjs.map