"use strict";Object.defineProperty(exports, "__esModule", {value: true});// src/common/data/decimal.ts
function decimal(value, decimalPlaces = 2) {
  return +(+value).toFixed(decimalPlaces);
}
function decimalFromCents(value, decimalPlaces = 2) {
  return +(+value / 10 ** decimalPlaces).toFixed(decimalPlaces);
}
function decimalToCents(value, decimalPlaces = 2) {
  return Math.round(+value * 10 ** decimalPlaces);
}
function decimalCentsPart(value, decimalPlaces = 2) {
  return decimalPlaces * (decimal(value, decimalPlaces) % 1);
}






exports.decimal = decimal; exports.decimalFromCents = decimalFromCents; exports.decimalToCents = decimalToCents; exports.decimalCentsPart = decimalCentsPart;
//# sourceMappingURL=chunk-YELWQAMG.cjs.map