"use strict";


var _chunk4D26JTTRcjs = require('../../chunk-4D26JTTR.cjs');
require('../../chunk-UFTHLJFJ.cjs');
require('../../chunk-VGLNW3NC.cjs');
require('../../chunk-2UTQQDPY.cjs');
require('../../chunk-SFUIGVPA.cjs');
require('../../chunk-X23ZSPZC.cjs');
require('../../chunk-QT3OZZO4.cjs');



var _chunkAG2W27IBcjs = require('../../chunk-AG2W27IB.cjs');


var _chunkHBGU4IMKcjs = require('../../chunk-HBGU4IMK.cjs');
require('../../chunk-UJPWHP47.cjs');
require('../../chunk-7L2G4SFK.cjs');
require('../../chunk-C5DWDWUS.cjs');
require('../../chunk-XTDX3HZA.cjs');
require('../../chunk-OOAMMLXY.cjs');
require('../../chunk-4B2XCWGL.cjs');
require('../../chunk-ORGSTQ42.cjs');
require('../../chunk-5CIFX7O6.cjs');
require('../../chunk-LXSY24WI.cjs');
require('../../chunk-KMITBP74.cjs');
require('../../chunk-7BMZYEWF.cjs');
require('../../chunk-S4V3EGNS.cjs');
require('../../chunk-N46W55MH.cjs');
require('../../chunk-UKD65B23.cjs');
require('../../chunk-Y6KPVUVD.cjs');
require('../../chunk-J42M6DF3.cjs');
require('../../chunk-L646RZQB.cjs');
require('../../chunk-ZYPCVNSG.cjs');
require('../../chunk-VFIICDKU.cjs');
require('../../chunk-PDXKNB3S.cjs');


var _chunkXR7AMYN7cjs = require('../../chunk-XR7AMYN7.cjs');
require('../../chunk-SLEHBFHV.cjs');
require('../../chunk-KMMN6P2X.cjs');
require('../../chunk-AGQV4BOO.cjs');
require('../../chunk-LURLRIHI.cjs');
require('../../chunk-67Q7IWIS.cjs');
require('../../chunk-B4JXPT6I.cjs');
require('../../chunk-KCBJGJ24.cjs');
require('../../chunk-RPAQV2V5.cjs');
require('../../chunk-SVJWXMAG.cjs');
require('../../chunk-RLHQ6YHC.cjs');
require('../../chunk-MPD2DJAD.cjs');
require('../../chunk-ZGKV237Z.cjs');
require('../../chunk-7BEQHGH5.cjs');
require('../../chunk-VAG3XY63.cjs');
require('../../chunk-FEYF6QXS.cjs');
require('../../chunk-SFVQNT7T.cjs');
require('../../chunk-N7OUNPMM.cjs');
require('../../chunk-Z4FNOCPD.cjs');
require('../../chunk-GWXPD6I7.cjs');


var _chunkN5KTMDVOcjs = require('../../chunk-N5KTMDVO.cjs');
require('../../chunk-B3U4FDQH.cjs');
require('../../chunk-YELWQAMG.cjs');
require('../../chunk-RHWKNEUH.cjs');
require('../../chunk-DRU33ZUG.cjs');
require('../../chunk-LHP7OTMV.cjs');
require('../../chunk-5BF2LEAU.cjs');
require('../../chunk-6T6PI6XG.cjs');
require('../../chunk-TUWUD5A6.cjs');
require('../../chunk-CUGOCLWN.cjs');


var _chunkW3WUDQICcjs = require('../../chunk-W3WUDQIC.cjs');
require('../../chunk-BXM45HLQ.cjs');
require('../../chunk-HHZVPIBD.cjs');
require('../../chunk-YY4AHBBL.cjs');
require('../../chunk-IMCDDJAJ.cjs');

// src/common/msg/rpc.spec.ts
var bobCount = 0;
var Bob = {
  hi(name) {
    return `Hi ${name}, I am Bob`;
  },
  bump() {
    bobCount += 1;
  },
  getCount() {
    return bobCount;
  }
};
var Alice = {
  hello(name) {
    return `Hello ${name}, my name is Alice`;
  }
};
describe("rpc async", () => {
  beforeEach(() => {
    bobCount = 0;
  });
  it("basic", async () => {
    const log = [];
    const [c1, c2] = _chunkHBGU4IMKcjs.createLocalChannelPair.call(void 0, );
    const serialize = (data) => {
      log.push(_chunkW3WUDQICcjs.cloneObject.call(void 0, data));
      return _chunk4D26JTTRcjs.encodeJson.call(void 0, data);
    };
    const deserialize = (data) => _chunk4D26JTTRcjs.decodeJson.call(void 0, data);
    const bob = _chunkAG2W27IBcjs.useRPC.call(void 0, Bob, {
      post: (data) => c1.postMessage(data),
      on: (data) => c1.on("message", (e) => data(e.data)),
      serialize,
      deserialize,
      stringHashPool: _chunkXR7AMYN7cjs.useStringHashPool.call(void 0, )
    });
    const alice = _chunkAG2W27IBcjs.useRPC.call(void 0, Alice, {
      // mark bob's `bump` as an event without response
      eventNames: ["bump"],
      post: (data) => c2.postMessage(data),
      on: (data) => c2.on("message", (e) => data(e.data)),
      serialize,
      deserialize,
      stringHashPool: _chunkXR7AMYN7cjs.useStringHashPool.call(void 0, )
    });
    expect(await bob.hello("Bob")).toEqual("Hello Bob, my name is Alice");
    expect(await alice.hi("Alice")).toEqual("Hi Alice, I am Bob");
    expect(void alice.bump()).toBeUndefined();
    expect(Bob.getCount()).toBe(0);
    await new Promise((resolve) => setTimeout(resolve, 100));
    expect(Bob.getCount()).toBe(1);
    c1.close();
    c2.close();
    expect(log).toMatchInlineSnapshot(`
      Array [
        Array [
          1,
          1,
          1335831723,
          "Bob",
        ],
        Array [
          3,
          1,
          "Hello Bob, my name is Alice",
        ],
        Array [
          1,
          2,
          1748694682,
          "Alice",
        ],
        Array [
          3,
          2,
          "Hi Alice, I am Bob",
        ],
        Array [
          2,
          1648103349,
        ],
      ]
    `);
  });
  it("hub", async () => {
    const [c1, c2] = _chunkHBGU4IMKcjs.createLocalChannelPair.call(void 0, );
    const serialize = (data) => _chunk4D26JTTRcjs.encodeJson.call(void 0, data);
    const deserialize = (data) => _chunk4D26JTTRcjs.decodeJson.call(void 0, data);
    const bobHub = _chunkAG2W27IBcjs.useRPCHub.call(void 0, {
      post: (data) => c1.postMessage(data),
      on: (data) => c1.on("message", (e) => data(e.data)),
      serialize,
      deserialize,
      stringHashPool: _chunkXR7AMYN7cjs.useStringHashPool.call(void 0, )
    });
    const bob = bobHub(Bob);
    const alice = _chunkAG2W27IBcjs.useRPC.call(void 0, Alice, {
      // mark bob's `bump` as an event without response
      eventNames: ["bump"],
      post: (data) => c2.postMessage(data),
      on: (data) => c2.on("message", (e) => data(e.data)),
      serialize,
      deserialize,
      stringHashPool: _chunkXR7AMYN7cjs.useStringHashPool.call(void 0, )
    });
    expect(await bob.hello("Bob")).toEqual("Hello Bob, my name is Alice");
    expect(await alice.hi("Alice")).toEqual("Hi Alice, I am Bob");
    expect(void alice.bump()).toBeUndefined();
    expect(Bob.getCount()).toBe(0);
    await new Promise((resolve) => setTimeout(resolve, 100));
    expect(Bob.getCount()).toBe(1);
    c1.close();
    c2.close();
  });
  it("timeout async", async (done) => {
    const [f1, f2] = _chunkHBGU4IMKcjs.createLocalChannelPair.call(void 0, );
    const rpc1 = _chunkAG2W27IBcjs.useRPC.call(void 0, {
      async echo(v, s = 5) {
        await _chunkN5KTMDVOcjs.sleep.call(void 0, s);
        return `${v}_1`;
      }
    }, {
      post: (data) => {
        f1.postMessage(data);
      },
      on: (data) => f1.on("message", (msg) => {
        void data(msg.data);
      }),
      timeout: 10
    });
    const rpc2 = _chunkAG2W27IBcjs.useRPC.call(void 0, {
      async echo(v, s = 5) {
        await _chunkN5KTMDVOcjs.sleep.call(void 0, s);
        return `${v}_2`;
      }
    }, {
      post: (data) => {
        f2.postMessage(data);
      },
      on: (data) => f2.on("message", (msg) => {
        void data(msg.data);
      }),
      timeout: 10
    });
    const r = await rpc1.echo("abc");
    expect(r).toMatchInlineSnapshot(`"abc_2"`);
    try {
      const r2 = await rpc1.echo("abc", 50);
      expect(false).toBe(true);
    } catch (err) {
      expect(err).toMatchInlineSnapshot(`[Error: rpc timeout on calling "echo"]`);
    }
  });
  it("async", async (done) => {
    function echo(n) {
      return n;
    }
    async function echoAsync(n) {
      return n;
    }
    expect(await echo(1)).toBe(1);
    expect(await echoAsync(2)).toBe(2);
  });
});
//# sourceMappingURL=rpc.spec.cjs.map