import { LogConfig } from '../../common/log/log-config.cjs';
import { LogLevelAliasType, LoggerInterface } from '../../common/log/log-base.cjs';

declare function Logger(name?: string, level?: LogLevelAliasType): LoggerInterface;
/** See LogConfig */
declare function LoggerFromConfig(config: LogConfig, name: string, level?: LogLevelAliasType): LoggerInterface;

export { Logger, LoggerFromConfig };
