"use strict";Object.defineProperty(exports, "__esModule", {value: true});// src/common/schema/utils.ts
function isSchemaObject(schema) {
  return schema._object != null;
}
function isSchemaOptional(schema) {
  return schema._optional === true;
}
function isSchemaDefault(schema) {
  return schema._default != null;
}
function isSchemaPrimitive(schema) {
  return !isSchemaObject(schema);
}
function isSchemaObjectFlat(schema) {
  return isSchemaObject(schema) && Object.values(schema._object).every(isSchemaPrimitive);
}







exports.isSchemaObject = isSchemaObject; exports.isSchemaOptional = isSchemaOptional; exports.isSchemaDefault = isSchemaDefault; exports.isSchemaPrimitive = isSchemaPrimitive; exports.isSchemaObjectFlat = isSchemaObjectFlat;
//# sourceMappingURL=chunk-NQWFR5HD.cjs.map