// src/common/schema/utils.ts
function isSchemaObject(schema) {
  return schema._object != null;
}
function isSchemaOptional(schema) {
  return schema._optional === true;
}
function isSchemaDefault(schema) {
  return schema._default != null;
}
function isSchemaPrimitive(schema) {
  return !isSchemaObject(schema);
}
function isSchemaObjectFlat(schema) {
  return isSchemaObject(schema) && Object.values(schema._object).every(isSchemaPrimitive);
}

export {
  isSchemaObject,
  isSchemaOptional,
  isSchemaDefault,
  isSchemaPrimitive,
  isSchemaObjectFlat
};
//# sourceMappingURL=chunk-REMT6GKB.js.map